/**
 * DO NOT EDIT
 *
 * This file was automatically generated by
 *   https://github.com/Polymer/tools/tree/master/packages/gen-typescript-declarations
 *
 * To modify these typings, edit the source file(s):
 *   src/ApiSummary.js
 */


// tslint:disable:variable-name Describing an API that's defined elsewhere.
// tslint:disable:no-any describes the API as best we are able today

import {LitElement, html} from 'lit-element';

import {AmfHelperMixin} from '@api-components/amf-helper-mixin/amf-helper-mixin.js';

export {ApiSummary};

/**
 * `api-summary`
 *
 * A summary view for an API base on AMF data model
 *
 * ## Styling
 *
 * `<api-summary>` provides the following custom properties and mixins for styling:
 *
 * Custom property | Description | Default
 * ----------------|-------------|----------
 * `--api-summary` | Mixin applied to this elment | `{}`
 * `--api-summary-color` | Color of text labels | ``
 * `--api-summary-url-font-size` | Font size of endpoin URL | `16px`
 * `--api-summary-url-background-color` | Background color of the URL section | `#424242`
 * `--api-summary-url-font-color` | Font color of the URL area | `#fff`
 * `--api-summary-separator-color` | Color of section separator | `rgba(0, 0, 0, 0.12)`
 */
declare class ApiSummary extends
  AmfHelperMixin(
  Object) {
  readonly styles: any;

  /**
   * `raml-aware` scope property to use.
   */
  aware: string|null|undefined;

  /**
   * A property to set to override AMF's model base URI information.
   * When this property is set, the `endpointUri` property is recalculated.
   */
  baseUri: string|null|undefined;

  /**
   * API title header level in value range from 1 to 6.
   * This is made for accessibility. It the component is used in a context
   * where headers order matters then this property is to be set to
   * arrange headers in the right order.
   */
  titleLevel: string|null|undefined;
  _providerName: string|null|undefined;
  _providerEmail: string|null|undefined;
  _providerUrl: string|null|undefined;
  _licenseName: string|null|undefined;
  _licenseUrl: string|null|undefined;
  _endpoints: any[]|null|undefined;
  _termsOfService: string|null|undefined;
  _version: string|null|undefined;
  _apiTitle: string|null|undefined;
  _description: string|null|undefined;
  _protocols: any[]|null|undefined;

  /**
   * Computes view model for endpoints list.
   *
   * @param webApi Web API model
   */
  _computeEndpoints(webApi: object|null): Array<object|null>|null|undefined;
  _processModelChange(): void;
  _webApiChanged(webApi: any): void;

  /**
   * Computes value of `apiTitle` property.
   *
   * @param shape Shape of AMF model.
   * @returns Description if defined.
   */
  _computeApiTitle(shape: object|null): String|null|undefined;

  /**
   * Computes value for `version` property
   *
   * @param webApi AMF's WebApi shape
   */
  _computeVersion(webApi: object|null): String|null|undefined;

  /**
   * Computes API's URI based on `amf` and `baseUri` property.
   *
   * @param server Server model of AMF API.
   * @param baseUri Current value of `baseUri` property
   * @param protocols List of supported protocols
   * @returns Endpoint's URI
   */
  _computeBaseUri(server: object|null, baseUri: String|null, protocols: Array<String|null>|null): String|null;

  /**
   * Computes information about provider of the API.
   *
   * @param webApi WebApi shape
   */
  _computeProvider(webApi: object|null): object|null|undefined;
  _computeName(provider: any): any;
  _computeEmail(provider: any): any;
  _computeUrl(provider: any): any;
  _computeToS(webApi: any): any;
  _computeLicense(webApi: any): any;

  /**
   * Computes a view model for supported operations for an endpoint.
   *
   * @param endpoint Endpoint model.
   */
  _endpointOperations(endpoint: object|null): Array<object|null>|unbdefined|null;
  _navigateItem(e: any): void;
  _apiHandler(e: any): void;
  render(): any;
  _titleTemplate(): any;
  _versionTemplate(): any;
  _descriptionTemplate(): any;

  /**
   * @returns A template for a server, servers, or no servers
   * whether it's defined in the main API definition or not.
   */
  _serversTemplate(): TemplateResult|String|null;

  /**
   * @param server Server definition
   * @returns Template for a server list items when there is more
   * than one server.
   */
  _serverListTemplate(server: object|null): TemplateResult|null;

  /**
   * @param server Server definition
   * @returns A template for a single server in the main API definition
   */
  _baseUriTemplate(server: object|null): TemplateResult|null;
  _protocolsTemplate(): any;
  _contactInfoTemplate(): any;
  _licenseTemplate(): any;
  _termsOfServiceTemplate(): any;
  _endpointsTemplate(): any;
  _endpointTemplate(item: any): any;
  _endpointPathTemplate(item: any): any;
  _endpointNameTemplate(item: any): any;
  _methodTemplate(item: any, endpoint: any): any;
  _sanitizeHTML(HTML: any): any;
}
